# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..11\n"; }
END {print "not ok 1\n" unless $loaded;}
use QNX;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Fork to form 2 processes.  On the parent do a system call to 
# start running the remote process script on node 2.  Set up a name 
# for the child and attach a proxy and a remote proxy on node 2.  
# Wait until the remote process sends the child a message and then
# send the remote process the pid of the remote proxy.  Wait to receive
# a message from the proxy and make sure it is the correct message.  
# Then detach the name, the proxy, and the remote proxy.

$prox_msg = 2;
$rem_node = 2;
$size = 1;
$nsize = 5;
$name = "/test/vproxy";
$rem_process = "perl ./t/rem_proc.pl";

if( fork )
{
	$id = &QNX::name_attach( 0, $name );
	$proxy = &QNX::proxy_attach( 0, $prox_msg, $size, -1 );
	$rem_proxy = &QNX::proxy_rem_attach( $rem_node, $proxy );
	print $proxy == -1 ? "not ok 2" : "ok 2", "\n";
	print $rem_proxy == -1 ? "not ok 3" : "ok 3", "\n";
	print $proxy == $rem_proxy ? "not ok 4" : "ok 4", "\n";
	$pid = &QNX::Receive( 0, $rmsg, $size );
	print $pid == -1 ? "not ok 5" : "ok 5", "\n";
	&QNX::Reply( $pid, $rem_proxy, $nsize );
	$r = &QNX::Receive( 0, $rmsg, $size );
	print $r == -1 ? "not ok 6" : "ok 6", "\n";
	print $rmsg == $prox_msg ? "ok 7" : "not ok 7", "\n";
	&QNX::name_detach( 0, $id );
	&QNX::proxy_rem_detach( $rem_node, $rem_proxy );
	&QNX::proxy_detach( $proxy );
}else{
	$r = system( "/usr/bin/on -n$rem_node $rem_process" );
	print $r == 0 ? "ok 11" : "not ok 11", "\n";
}
